<div id="content">

  <mat-form-field>
    <mat-label>Filter</mat-label>
    <input matInput (keyup)="applyFilter($event)" placeholder="Ex. Walk the dog" #input>
  </mat-form-field>

    <div class="mat-elevation-z8">
      <table mat-table [dataSource]="dataSource" matSort>

        <ng-container matColumnDef="status">
          <th mat-header-cell *matHeaderCellDef mat-sort-header> Status </th>
          <td mat-cell *matCellDef="let row"> <mat-checkbox class="example-margin" [checked]="row.isDone" (click)="updateStatus(row)"></mat-checkbox> </td>
        </ng-container>

        <ng-container matColumnDef="time">
          <th mat-header-cell *matHeaderCellDef mat-sort-header> Time needed </th>
          <td mat-cell *matCellDef="let row"> {{row.time}} minute(s)</td>
        </ng-container>

        <ng-container matColumnDef="title">
          <th mat-header-cell *matHeaderCellDef mat-sort-header> Title </th>
          <td mat-cell *matCellDef="let row"> {{row.title}} </td>
        </ng-container>

        <ng-container matColumnDef="priority">
          <th mat-header-cell *matHeaderCellDef mat-sort-header> Priority </th>
          <td mat-cell *matCellDef="let row" [style.color]="row.color"> {{row.priority}} </td>
        </ng-container>

        <ng-container matColumnDef="content">
          <th mat-header-cell *matHeaderCellDef mat-sort-header> Description </th>
          <td mat-cell *matCellDef="let row"> {{row.content}}</td>
        </ng-container>

        <ng-container matColumnDef="date">
          <th mat-header-cell *matHeaderCellDef mat-sort-header> Days left </th>
          <td mat-cell *matCellDef="let row"> {{daysLeft(row.date, row.isDone)}} </td>
        </ng-container>

        <ng-container matColumnDef="action">
          <th mat-header-cell *matHeaderCellDef mat-sort-header> Action </th>
          <td mat-cell *matCellDef="let row">
            <button mat-raised-button color="accent" (click)="fillDialog(row)">Modify</button>
            <button mat-raised-button color="primary" (click)="deleteTask(row._id)">Delete</button>
          </td>
        </ng-container>

        <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
        <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>

        <!-- Row shown when there is no matching data. -->
        <tr class="mat-row" *matNoDataRow>
          <td class="mat-cell" colspan="4">No data matching the filter "{{input.value}}"</td>
        </tr>
      </table>

      <mat-paginator [pageSizeOptions]="[5, 10, 25, 100]"></mat-paginator>
    </div>

<!-- Trigger/Open The Modal -->

<!-- The Modal -->
<div id="myModal" class="modal">

  <!-- Modal content -->
  <div class="modal-content">
    <span onclick="myModal.style.display='none';" class="close">&times;</span>
    <form [formGroup]="alterRecord" class="example-form" #taskform = "ngForm" (ngSubmit)="updateTask(alterRecord)">
      <p>
        <mat-form-field class="example-full-width">
          <mat-label>Title</mat-label>
          <textarea matInput id="title" formControlName="title"></textarea>
          <mat-error *ngIf="alterRecord.controls['title'].hasError('required')">
            Title is <strong>required</strong>
          </mat-error>
        </mat-form-field>
        <mat-form-field class="example-full-width">
          <mat-label>Description</mat-label>
          <textarea matInput id="description" formControlName = "content"></textarea>
        </mat-form-field>
      </p>

      <table class="example-full-width" cellspacing="0"><tr>
        <td><mat-form-field class="example-full-width">
          <mat-label>Time needed</mat-label>
          <mat-hint align="start"><strong>Number input, in minutes</strong> </mat-hint>
          <input matInput type="number" oninput="validity.valid||(value='');" min="1" id="time"formControlName = "time" placeholder="Eg. 10">
          <mat-error *ngIf="alterRecord.controls['time'].hasError('required')">
            Time is <strong>required</strong>
          </mat-error>
        </mat-form-field></td>
        <td>

        <mat-form-field appearance="fill">
          <mat-label>Priority</mat-label>
          <mat-select placeholder="Priority" formControlName="priority">
            <mat-option *ngFor="let prior of priorities" [value]="prior">
              {{prior.name}}
            </mat-option>
          </mat-select>
          <mat-error *ngIf="alterRecord.controls['priority'].hasError('required')">
            Priority is <strong>required</strong>
          </mat-error>
        </mat-form-field></td>
      </tr></table>

      <p>
        <mat-form-field appearance="fill">
          <mat-label>Deadline</mat-label>
          <input id="date" matInput name = "date" [readonly]="true" [matDatepicker]="picker" formControlName="date">
          <mat-datepicker-toggle matSuffix [for]="picker"></mat-datepicker-toggle>
          <mat-datepicker #picker></mat-datepicker>
          <mat-error *ngIf="alterRecord.controls['date'].hasError('required')">
            Date is <strong>required</strong>
          </mat-error>
        </mat-form-field>
      </p>

      <button mat-raised-button color="primary" type="submit">Submit</button>
    </form>
  </div>

</div>
</div>

